// #autoload
// #name = Quick Menu
// #version = 1.5
// #date = August 25, 2002
// #category = Automation
// #author = Lou Cypher
// #warrior = LouCypher
// #email = asta_llama_lincoln@hotmail.com
// #web = http://www.tribes2.com
// #description = Quick Menu chat and command interface
// #status = beta
// #readme = quickmenu.txt
// #credit = Dia-Menz - QuickMenu is a modified version of NIR-CHAT with bugfixes
// #credit = Nextwish - code used from his modified version of VoidSay
// #credit = Ego - additional code backported from his VP2 version of QuickMenu

package QuickMenu {

 	function PlayGui::onWake( %this )
	{

		parent::onWake( %this );
    	if (isObject(HM) && isObject(HudMover))
    		hudmover::addhud(QuickMenuHud, "Quick Menu");
	}

	function OptionsDlg::onWake( %this ) {
		if($QuickBind == false) {
			$RemapName[$RemapCount]="Quick Menu";
			$RemapCmd[$RemapCount]="activateQuickMenuHud";
			$RemapCount++;
			$QuickBind = true;
		}
		parent::onWake( %this );
	}
 
    function clientCmdSetPilotVehicleKeys() {
		passengerKeys.copyBind(moveMap, activateQuickMenuHud);
		parent::clientCmdSetPilotVehicleKeys();
	}
 
    function clientCmdSetPassengerVehicleKeys() {
		passengerKeys.copyBind(moveMap, activateQuickMenuHud);
		parent::clientCmdSetPassengerVehicleKeys();
	}

	function DebriefGui::onWake( %this ){
		parent::onWake( %this );
		debriefMap.copybind(moveMap, activateQuickMenuHud);
	}

	function DispatchLaunchMode() {
		parent::DispatchLaunchMode();
		exec("gui/EditQuickMenuDlg.gui");
		exec("gui/QuickMenuHudDlg.gui");
		exec("gui/EditQuickMenuGui.gui");
		exec("gui/EditQuickCommandDlg.gui");
		exec("gui/QuickEditMenu.gui");
	}

    function LaunchToolbarDlg::onWake(%this)
    {

         parent::onWake(%this);
         LaunchToolbarMenu.addSeparator();
         LaunchToolbarMenu.add( 24, "QUICK MENU" );
    }

    function LaunchToolbarMenu::onSelect(%this, %id, %text)
    {

         parent::onSelect(%this, %id, %text);
       switch(%id)
       {
          case 24:
               Canvas.pushDialog(QuickEditMenu);
    		   playGui.add($IPCGUi);
       }
    }

// ------------------- Chat In Game Section -------------------------------

	// Function called by the prefs file to create menu
	function startQuickMenu(%heading) {
		%key = getSubStr( %heading, 0, strpos(%heading, ":") );
		%text = getSubStr(%heading, (strpos(%heading, ":")+2), (strlen(%heading) - (strpos(%heading, ":")+2)));
		%menu = new ActionMap();
		QuickMenuList.add( %menu );
		%cm = $CurrentQuickMenu;
		%cm.bindCmd(keyboard, %key, "setQuickMenu(\"" @ %text @ "\", " @ %menu @ ");", "");
		%cm.option[%cm.optionCount] = %key @ ": " @ %text;
		%cm.command[%cm.optionCount] = %menu;
		%cm.isMenu[%cm.optionCount] = 1;
        %cm.menuNum[%cm.optionCount] = $QuickMenuNum;
		%cm.optionCount++;
		%menu.parent = %cm;
		%menu.bindCmd(keyboard, escape, "cancelQuickMenu();", "");
		%menu.optionCount = 0;
		$CurrentQuickMenu = %menu;

        $QuickCmdKey[$QuickMenuNum] = %key;
        $QuickCmdText[$QuickMenuNum] = %text;
        $QuickCmdMenu[$QuickMenuNum] = true;
        $QuickMenuNum++;
	}


	function endQuickMenu() {
		$CurrentQuickMenu = $CurrentQuickMenu.parent;
	}

	// Function to creat an object array and properties for each saved command, called from prefs file
	function addQuick(%keyDesc, %command, %sound, %scope, %anim) {
		%key = getSubStr( %keyDesc, 0, strpos(%keyDesc, ":") );
		%text = getSubStr(%keyDesc, (strpos(%keyDesc, ":")+2), (strlen(%keyDesc) - (strpos(%keyDesc, ":")+2)));
		%cm = $CurrentQuickMenu;
		%cm.bindCmd(keyboard, %key, "issueQuickCmd(" @ %cm @ "," @ %cm.optionCount @ ");", "");
		%cm.option[%cm.optionCount] = %key @ ": " @ %text;
		%cm.command[%cm.optionCount] = %command;
        %cm.sound[%cm.optionCount] = %sound;
        %cm.scope[%cm.optionCount] = %scope;
        %cm.animation[%cm.optionCount] = %anim;
		%cm.isMenu[%cm.optionCount] = 0;
        %cm.menuNum[%cm.optionCount] = $QuickMenuNum;
        %cm.optionCount++;

        $QuickCmdSound[$QuickMenuNum] = %sound;
        $QuickCmdScope[$QuickMenuNum] = %scope;
        $QuickCmdAnimation[$QuickMenuNum] = %anim;
        $QuickCmdKey[$QuickMenuNum] = %key;
        $QuickCmdText[$QuickMenuNum] = %text;
        $QuickCmdSpeak[$QuickMenuNum] = %command;
        $QuickCmdMenu[$QuickMenuNum] = false;
        
        $QuickMenuNum++;
	}

	// Actual Command issued to server
	function issueQuickCmd( %menu, %index ) {

         %menuNum = %menu.menuNum[%index];
         
         switch($QuickCmdScope[%menuNum]) {
               case 0:      // Sends to team
                   if ($QuickCmdSound[%menuNum]!$="") {
                       %QuickMsg = $QuickCmdSpeak[%menuNum] @ "~w" @ $QuickCmdSound[%menuNum];
                       %QuickMsg = addTaggedString(%QuickMsg);
                   } else {
                       %QuickMsg = addTaggedString($QuickCmdSpeak[%menuNum]);
                   }
                   commandToServer( 'TeamMessageSent', %QuickMsg );

                   if ($QuickCmdAnimation[%menuNum]!$="") {
                       %anim = $QuickCmdAnimation[%menuNum];
                        echo(%anim);
                		commandToServer('PlayAnim', %anim);
                   }
               case 1:       // Sends Global
                   if ($QuickCmdSound[%menuNum]!$="") {
                       %QuickMsg = $QuickCmdSpeak[%menuNum] @ "~w" @ $QuickCmdSound[%menuNum];
                       %QuickMsg = addTaggedString(%QuickMsg);
                   } else {
                       %QuickMsg = addTaggedString($QuickCmdSpeak[%menuNum]);
                   }
                   commandToServer( 'messageSent', %QuickMsg );

                   if ($QuickCmdAnimation[%menuNum]!$="") {
                       %anim = $QuickCmdAnimation[%menuNum];
                	   commandToServer('PlayAnim', %anim);
                   }

               case 2:      // Canned Chat
                   %QuickMsg = addTaggedString($QuickCmdSpeak[%menuNum]);
                   commandToServer( 'CannedChat', %QuickMsg, false );
               case 3:      // function
                   eval($QuickCmdSpeak[%menuNum]);
         }
         cancelQuickMenu();
	}


	// Fired on keypress
	function activateQuickMenuHud(%make){
		if(%make && !TaskHudDlg.isVisible())
			showQuickMenuHud();
	}


	// Function that opens menu
	function showQuickMenuHud() {
		Canvas.pushDialog(QuickMenuHudDlg);
		QuickMenuHudDlg.setVisible(true);
		setQuickMenu(Root, $RootQuickMenu);
	}

	
	// Initializes and displays the menu's text
	function setQuickMenu( %name, %menu ) {
		for ( %i = 0; %i < $QuickMenuHudLineCount; %i++ )
			QuickMenuHud.remove( $QuickMenuHudText[%i] );

		$QuickMenuHudLineCount = %menu.optionCount + 1;
		QuickMenuHud.extent = "170" SPC ( $QuickMenuHudLineCount * 10 ) + 8;

		// First add the menu title line:
		$QuickMenuHudText[0] = new GuiTextCtrl() {
			profile = "GuiQuickMenuProfile";
			horizSizing = "left";
			vertSizing = "top";
			position = "5 3";
			extent = "0 0";
			minExtent = "8 8";
			visible = "1";
			setFirstResponder = "0";
			modal = "1";
			helpTag = "0";
			text = "\c2" @ %name @ " Menu:";
		};
		QuickMenuHud.add( $QuickMenuHudText[0] );

		// Now add all of the menu options:
		for ( %option = 0; %option < %menu.optionCount; %option++ ) {
			%yOffset = ( %option * 10 ) + 15;

			if ( %menu.isMenu[%option] == 1 ) {
				$QuickMenuHudText[%option + 1] = new GuiTextCtrl() {
					profile = "GuiQuickMenuProfile";
					horizSizing = "left";
					vertSizing = "top";
					position = "5 " @ %yOffset;
					extent = "0 0";
					minExtent = "8 8";
					visible = "1";
					setFirstResponder = "0";
					modal = "1";
					helpTag = "0";
					text = "  " @ %menu.option[%option];
				};
			}
			else {
				$QuickMenuHudText[%option + 1] = new GuiTextCtrl() {
					profile = "GuiQuickMenuProfile";
					horizSizing = "left";
					vertSizing = "top";
					position = "5 " @ %yOffset;
					extent = "0 0";
					minExtent = "8 8";
					visible = "1";
					setFirstResponder = "0";
					modal = "1";
					helpTag = "0";
					text = "  " @ %menu.option[%option];
				};
			}
			QuickMenuHud.add( $QuickMenuHudText[%option + 1] );
		}

		%menu.bindCmd(keyboard, "anykey", "cancelQuickMenu();", "");			// Change this to enable ctrl/shifts
		$CurrentQuickMenu.pop();
		$CurrentQuickMenu = %menu;
		%menu.push();
	}

	function cancelQuickMenu() {
		$CurrentQuickMenu.pop();
		$CurrentQuickMenu = $RootQuickMenu;
		Canvas.popDialog(QuickMenuHudDlg);
		QuickMenuHudDlg.setVisible(false);
	}


// ----------- Edit Menu Section ----------------------------------------------------


	function activateQuickMenu( %filename ) {
		if ( isFile( %filename ) ) {
			QuickMenuList.clear();
			$RootQuickMenu = new ActionMap();
			QuickMenuList.add( $RootQuickMenu );
			$CurrentQuickMenu = $RootQuickMenu;
			$CurrentQuickMenu.optionCount = 0;
			$CurrentQuickMenu.bindCmd(keyboard, escape, "cancelQuickMenu();", "");
            $QuickMenuNum = 0;
			exec( %filename );
		}
		else
			error( "Chat menu file \"" @ %filename @ "\" not found!" );
	}


	function QuickEditMenu::onWake( %this ) {
		fillQuickMenuTree();
	}


	function EditQuickMenuGui::onSleep( %this ) {
		QuickGuiTree.clear();
	}

    // Sets text and value of first root item
	function newQuickMenu() {
		QuickGuiTree.clear();
		%guiRoot = QuickGuiTree.getFirstRootItem();
		QuickGuiTree.insertItem( %guiRoot, "QUICK MENU", 0 );
		QuickGuiTree.dirty = true;
	}


	function saveQuickMenu() {
		doSaveQuickMenu( "qmprefs.cs" );
	}


	function resetQuickMenu() {
		doLoadQuickMenu( "qmprefs.cs" );
	}


     // Opens Prefs File for writting
    function doSaveQuickMenu( %filename ) {
		%filename = fileBase( %filename );
		if ( %filename $= "" )
			return;

		new fileObject( "saveFile" );
		saveFile.openForWrite( "prefs/" @ %filename @ ".cs" );

		saveFile.writeLine( "//------------------------------------------------------------------------------" );
		saveFile.writeLine( "//" );
		saveFile.writeLine( "// Tribes 2 Quick Menu." );
        saveFile.writeLine( "// Created by LouCypher (asta_llama_lincoln@hotmail.com) " );
		saveFile.writeLine( "// Based on NIR-CHAT by Dia-Menz" );
		saveFile.writeLine( "// Credit goes to all authors whose code NIR-CHAT is based on" );
		saveFile.writeLine( "// Additional code borrowed from Nextwish's modified Voidsay" );
		saveFile.writeLine( "// Additional code borrowed from Ego's modified QuickMenu" );
		saveFile.writeLine( "//" );
		saveFile.writeLine( "//------------------------------------------------------------------------------" );
		saveFile.writeLine( " " );

		%rootItem = QuickGuiTree.getFirstRootItem();
		writeQuickTreeNode( saveFile, QuickGuiTree.getChild( %rootItem ), "" );

		saveFile.close();
		saveFile.delete();

		QuickGuiTree.dirty = false;

		MessageBoxOK( "SAVED", "Save successful." );
	}


     // Writes the Tree into the prefs file
	function writeQuickTreeNode( %file, %item, %space ) {
  
        %menuNum = QuickGuiTree.getItemValue( %item );
        %key = $QuickCmdKey[%menuNum];
        %text = $QuickCmdText[%menuNum];
        %sound = $QuickCmdSound[%menuNum];
        %scope = $QuickCmdScope[%menuNum];
        %anim = $QuickCmdAnimation[%menuNum];
        %chat = $QuickCmdSpeak[%menuNum];

		if ( $QuickCmdMenu[%menuNum] ) {
            %temp = QuickGuiTree.getItemText( %item );
            %key = getSubStr( %temp, 0, strpos(%temp, ":") );
		    %text = getSubStr(%temp, (strpos(%temp, ":")+2), (strlen(%temp) - (strpos(%temp, ":")+2)));
			%file.writeLine( %space @ "startQuickMenu( \"" @ %key @ ": " @ %text @ "\" );" );
			%child = QuickGuiTree.getChild( %item );
			if ( %child )
				writeQuickTreeNode( %file, %child, ("    " @ %space) );
			%file.writeLine( %space @ "endQuickMenu(); // " @ %text );
			%file.writeLine( " ");
		}
		else {
            if (%sound !$= "" ) {
                %file.writeLine( %space @ "addQuick( \"" @ %key @ ": " @ %text @ "\", \"" @ %chat @ "\", \"" @ %sound @ "\", " @ %scope @ " , \"" @ %anim @"\" );" );
            } else {
                %file.writeLine( %space @ "addQuick( \"" @ %key @ ": " @ %text @ "\", \"" @ %chat @ "\", \"\", " @ %scope @ " , \"" @ %anim @"\" );" );
            }
		}

		%sibling = QuickGuiTree.getNextSibling( %item );
		if ( %sibling != 0 )
			writeQuickTreeNode( %file, %sibling, %space );
	}


	function doLoadQuickMenu( %filename ) {
		QuickGuiTree.clear();
		activateQuickMenu( %filename );
		fillQuickMenuTree();
	}


	function fillQuickMenuTree() {
		%guiRoot = QuickGuiTree.getFirstRootItem();
		%newGuiId = QuickGuiTree.insertItem( %guiRoot, "QUICK MENU", 0 );
		traverseQuickMenu( %newGuiId, $RootQuickMenu );
		QuickGuiTree.expandItem( %newGuiId );
		QuickGuiTree.selectItem( %newGuiId );
		QuickGuiTree.dirty = false;
	}


     // Fills in edit menu from prefs file. %menu object defined above
    function traverseQuickMenu( %guiID, %menu ) {
		for ( %i = 0; %i < %menu.optionCount; %i++ ) {
			%text = %menu.option[%i];

              %menuNum = %menu.menuNum[%i];

            // Inserts if its a menu else add a item
			if ( $QuickCmdMenu[%menuNum] ) {
				%newGuiID = QuickGuiTree.insertItem( %guiID, %text, 0 );
				traverseQuickMenu( %newGuiID, %menu.command[%i] );
			}
			else {
                %text = %text @ " - ( " @ %menu.command[%i] @ " )";
				QuickGuiTree.insertItem( %guiID, %text, %menuNum );
			}
		}
	}


	function QuickGuiTree::onRightMouseDown( %this, %item, %pos ) {
		QuickGuiTree.selectItem( %item );
		QuickItemActionPopup.awaken( %item, %pos );
	}


	function QuickItemActionPopup::awaken( %this, %item, %pos ) {
		%this.position = %pos;
		%this.clear();

		%treeRoot = QuickGuiTree.getFirstRootItem();
        %menuNum = QuickGuiTree.getItemValue( %item );
        %isMenu = $QuickCmdMenu[%menuNum];

		if ( %item != %treeRoot )
		%this.addEntry( "Edit", 0 );

		if ( %isMenu ) {
			%this.addEntry( "Add menu", 1 );
			%this.addEntry( "Add command", 2 );
		}

		if ( QuickGuiTree.getPrevSibling( %item ) )
			%this.addEntry( "Move up", 3 );

		if ( QuickGuiTree.getNextSibling( %item ) )
			%this.addEntry( "Move down", 4 );

		if ( %item != %treeRoot )
			%this.addEntry( "Delete", 5 );

		if ( %this.numEntries == 0 )
			return;

		Canvas.pushDialog( QuickItemActionDlg );
		%this.forceOnAction();
	}


	function QuickItemActionPopup::addEntry( %this, %text, %id ) {
		%this.numEntries++;
		%this.add( %text, %id );
	}


	function QuickItemActionPopup::reset( %this ) {
		%this.numEntries = 0;
		%this.forceClose();
		Canvas.popDialog( QuickItemActionDlg );
	}

     // Runs when you've select a tree item, decides what item is and sends to right function
	function QuickItemActionPopup::onSelect( %this, %id, %text ) {
		%item = QuickGuiTree.getSelectedItem();
		switch ( %id ) {
			case 0: // Edit
				%temp = QuickGuiTree.getItemText( %item );
				%key = getSubStr( %temp, 0, strpos(%temp, ":") );
                %text = getSubStr(%temp, (strpos(%temp, ":")+2), (strlen(%temp) - (strpos(%temp, ":")+2)));
				%command = QuickGuiTree.getItemValue( %item );
                if ( strcmp( %command, "0" ) == 0 )
					editQuickMenu( %key, %text, "doEditQuickMenu" );
				else {
					editSelectedQuickItem();
				}
			case 1: // Add menu
				editQuickMenu( "", "", "doNewQuickMenu" );
			case 2: // Add command
				editQuickCommand( "", "", "", "doNewQuickCommand", 0, 0 );
			case 3: // Move up
				QuickGuiTree.moveItemUp( %item );
				QuickGuiTree.dirty = true;
			case 4: // Move down
				%nextItem = QuickGuiTree.getNextSibling( %item );
				QuickGuiTree.moveItemUp( %nextItem );
				QuickGuiTree.dirty = true;
			case 5: // Delete
				QuickGuiTree.removeItem( %item );
				QuickGuiTree.dirty = true;
		}
		%this.reset();
	}


	function QuickItemActionPopup::onCancel( %this ) {
		%this.reset();
	}


    // Runs when you double click on an item. checks if its a menu or a item
    // The value of the item, only determines if its an item or a menu.
    function editSelectedQuickItem() {
		%item = QuickGuiTree.getSelectedItem();
		if ( %item != QuickGuiTree.getFirstRootItem() ) {

            %menuNum = QuickGuiTree.getItemValue( %item );
            %temp = QuickGuiTree.getItemText( %item );
			if ( strlen( %temp ) > 0 ) {
				%key = getSubStr( %temp, 0, strpos(%temp, ":") );
                %text = getSubStr(%temp, (strpos(%temp, ":")+2), (strlen(%temp) - (strpos(%temp, ":")+2)));
				%command = QuickGuiTree.getItemValue( %item );

				if ( $QuickCmdMenu[%menuNum] )
					editQuickMenu( %key, %text, "doEditQuickMenu" );
				else {
                    %key = $QuickCmdKey[%menuNum];
                    %text = $QuickCmdText[%menuNum];
                    %chat = $QuickCmdSpeak[%menuNum];
                    %sound = $QuickCmdSound[%menuNum];
                    %scope = $QuickCmdScope[%menuNum];
                    %anim = $QuickCmdAnimation[%menuNum];
                    %soundfile = $QuickCmdSound[%menuNum];
                    for(%i = 1; %i <= $QuickNum; %i++) {
                       if (%soundfile $= $QuickSound[%i]) {
                          %sound = %i;
                       }
                    }
                    for(%i = 1; %i <= $QuickAnim; %i++) {
                       if (%anim $= $QuickAnimation[%i]) {
                          %anim = %i;
                       }
                    }

					editQuickCommand( %key, %text, %chat, "doEditQuickCommand", %sound, %scope, %anim );
				}
             }
		}
	}

     // Opens the menu edit dialog box and passes vars to fill in
	function editQuickMenu( %key, %text, %callback ) {
		$QuickECI::key = %key;
		$QuickECI::text = %text;
		$QuickECI::OKCommand = %callback @ "($QuickECI::key, $QuickECI::text);";
		Canvas.pushdialog( EditQuickMenuDlg );
	}

      // Opens the item edit dialog box and passes vars to fill in
	function editQuickCommand( %key, %text, %chat, %callback, %sound, %scope, %anim ) {
		$QuickECI::key = %key;
		$QuickECI::text = %text;
		$QuickECI::command = %chat;
		$QuickECI::OKCommand = %callback @ "($QuickECI::key, $QuickECI::text, $QuickECI::command, QuickSound.getSelected(), QuickScope.getSelected(), QuickAnimation.getSelected());";
		Canvas.pushdialog( EditQuickCommandDlg );
        QuickSound.setSelected(%sound);
        QuickScope.setSelected(%scope);
        QuickAnimation.setSelected(%anim);
	}
 
     // Called when you click OK after editing a menu
	function doEditQuickMenu( %key, %text ) {
		if ( strlen( %key ) && strlen( %text ) ) {
			Canvas.popdialog( EditQuickMenuDlg );
			%item = QuickGuiTree.getSelectedItem();
			%newText = %key @ ": " @ %text;
			QuickGuiTree.editItem( %item, %newText, "0" );
			CheckQuickSiblings( %item );
			QuickGuiTree.dirty = true;
		}
	}


    // Called when you click OK after editing a item
    function doEditQuickCommand( %key, %text, %command, %sound, %scope, %anim ) {
		if ( strlen( %key ) && strlen( %text )) {
			Canvas.popdialog( EditQuickCommandDlg );
			%item = QuickGuiTree.getSelectedItem();
            %menuNum = QuickGuiTree.getItemValue( %item );

            $QuickCmdSound[%menuNum] = $QuickSound[%sound];
            $QuickCmdScope[%menuNum] = %scope;
            $QuickCmdAnimation[%menuNum] = $QuickAnimation[%anim];
            $QuickCmdKey[%menuNum] = %key;
            $QuickCmdText[%menuNum] = %text;

            if (%scope $= "2") {
                $QuickCmdSpeak[%menuNum] = $QuickCanned[%sound];
                %command = detag($QuickCanned[%sound]);
            } else {
                $QuickCmdSpeak[%menuNum] = %command;
            }
            
            %newText = %key @ ": " @ %text @ " - ( " @ %command @ " )";
			QuickGuiTree.editItem( %item, %newText, %menuNum);
			CheckQuickSiblings( %item );
			QuickGuiTree.dirty = true;
		}
	}

     // Runs when new menu is created
	function doNewQuickMenu( %key, %text ) {
		if ( strlen( %key ) && strlen( %text ) ) {
			Canvas.popdialog( EditQuickMenuDlg );
			%item = QuickGuiTree.getSelectedItem();
			%newText = %key @ ": " @ %text;
			%newItem = QuickGuiTree.insertItem( %item, %newText, "0" );
			QuickGuiTree.expandItem( %item );
			QuickGuiTree.selectItem( %newItem );
			CheckQuickSiblings( %newItem );
			QuickGuiTree.dirty = true;

   		}
	}

     // Runs when new item is created
	function doNewQuickCommand( %key, %text, %command, %sound, %scope, %anim ) {
		if ( strlen( %key ) && strlen( %text )) {
			Canvas.popdialog( EditQuickCommandDlg );
			%item = QuickGuiTree.getSelectedItem();
            %menuNum = $QuickMenuNum;
            
            $QuickCmdSound[%menuNum] = $QuickSound[%sound];
            $QuickCmdScope[%menuNum] = %scope;
            $QuickCmdAnimation[%menuNum] = $QuickAnimation[%anim];
            $QuickCmdKey[%menuNum] = %key;
            $QuickCmdText[%menuNum] = %text;
            $QuickCmdMenu[%menuNum] = false;

            if (%scope $= "2") {
                $QuickCmdSpeak[%menuNum] = $QuickCanned[%sound];
                %command = $QuickCanned[%sound];
            } else {
                $QuickCmdSpeak[%menuNum] = %command;
            }
            
            $QuickMenuNum++;
            %newText = %key @ ": " @ %text @ " - ( " @ %command @ " )";
			%newItem = QuickGuiTree.insertItem( %item, %newText, %menuNum );
			QuickGuiTree.expandItem( %item );
			QuickGuiTree.selectItem( %newItem );
			CheckQuickSiblings( %newItem );
			QuickGuiTree.dirty = true;
		}
	}


	function CheckQuickSiblings( %item ) {
		%allClear = true;
		%sibling = QuickGuiTree.getPrevSibling( %item );
		while ( %sibling != 0 ) {
			%siblingKey = getSubStr( QuickGuiTree.getItemText( %sibling ), 0, strpos(QuickGuiTree.getItemText( %sibling ), ":") );
			if ( %siblingKey $= $QuickECI::key ) {
				%allClear = false;
				break;
			}
			%sibling = QuickGuiTree.getPrevSibling( %sibling );
		}

		if ( %allClear ) {
			%sibling = QuickGuiTree.getNextSibling( %item );
			while ( %sibling != 0 ) {
				%siblingKey = getSubStr( QuickGuiTree.getItemText( %sibling ), 0, strpos(QuickGuiTree.getItemText( %sibling ), ":") );
				if ( %siblingKey $= $QuickECI::key ) {
					%allClear = false;
					break;
				}
				%sibling = QuickGuiTree.getNextSibling( %sibling );
			}
		}

		if ( !%allClear ) {

            %menuNum = QuickGuiTree.getItemValue( %item );
            if ( $QuickCmdMenu[%menuNum] )
				%text1 = restWords( QuickGuiTree.getItemText( %item ) );
			else {
				%temp = QuickGuiTree.getItemText( %item );
				%text1 = getWords( %temp, 1, getWordCount( %temp ) - 5 );
			}
            %menuNum = QuickGuiTree.getItemValue( %sibling );
            if ( $QuickCmdMenu[%menuNum] )
				%text2 = restWords( QuickGuiTree.getItemText( %sibling ) );
			else {
				%temp = QuickGuiTree.getItemText( %sibling );
				%text2 = getWords( %temp, 1, getWordCount( %temp ) - 5 );
			}
			MessageBoxOK( "WARNING", "Menu siblings \"" @ %text1 @ "\" and \"" @ %text2 @ "\" are both bound to the \'" @ %siblingKey @ "\' key!" );
		}
		return %allClear;
	}


	function leaveQuickMenuEditor() {
		if ( QuickGuiTree.dirty )
			MessageBoxYesNo( "CHANGES", "Do you want to save your changes?", "saveQuickMenu(); reallyLeaveQuickMenuEditor();", "reallyLeaveQuickMenuEditor();" );
		else
			reallyLeaveQuickMenuEditor();
	}

	function reallyLeaveQuickMenuEditor() {
		activateQuickMenu( "prefs/qmprefs.cs" );
		QuickGuiTree.clear();
		Canvas.popdialog( EditQuickMenuGui );
		Canvas.popdialog( QuickEditMenu );
	}

  function QuickSayInstall(%canned, %msg, %file)
	{
		if(!$QuickNum) {
//		      $QuickNum=0;

              QuickSound.add("- None -", 0);
              QuickSound.setSelected(0);
              QuickScope.add("Team",0);
              QuickScope.add("Global",1);
              QuickScope.add("Canned Chat",2);
              QuickScope.add("Command",3); // added to perform function
              QuickScope.setSelected(0);
        }
		$QuickNum++;
		$QuickMessage[$QuickNum]=%msg;
		$QuickSound[$QuickNum]=%file;
        $QuickCanned[$QuickNum]= %canned;
		QuickSound.add(%msg, $QuickNum);
	}

	function QuickAnimInstall(%desc, %anim)
	{
		if(!$QuickAnim) {
//		      $QuickAnim=0;

              QuickAnimation.add("- None -", 0);
              QuickAnimation.setSelected(0);
        }
        $QuickAnim++;
		$QuickAnimation[$QuickAnim]=%anim;
		QuickAnimation.add(%desc, $QuickAnim);
	}




    function QuickSayPlaySound(){
      %b=QuickSound.getValue();
          for(%d=1; $QuickMessage[%d]!$=""; %d++)
	      {
		    if($QuickMessage[%d]$=%b)
		      {
                %MsgNum=%d;
		      }
	      }
       %voice=getField($pref::Player[$pref::Player::Current], 3);
       %pitchval=GMW_VoicePitchSlider.getValue();
       %pitch = getValidVoicePitch(%voice, %pitchval);
       %wav = "voice/"@%voice@"/"@$QuickSound[%MsgNum]@".wav";
       %playsound = alxCreateSource( AudioGui, %wav );
       alxSourcef(%playsound, "AL_PITCH", %pitch);
       echo(%wav);
       alxPlay( %playsound );
    }
};
activatepackage(QuickMenu);

new SimSet( QuickMenuList );
activateQuickMenu("prefs/qmprefs.cs");
$QuickMenuHudLineCount = 0;
$QuickBind = "false";

